
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class League_finish_awardsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const league_finish_awards = await db.league_finish_awards.create(
            {
                id: data.id || undefined,
        
        finish_rank: data.finish_rank
        ||
        null
            ,
            
        bonus_points: data.bonus_points
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await league_finish_awards.setLeague( data.league || null, {
            transaction,
        });
        
        await league_finish_awards.setPlayer( data.player || null, {
            transaction,
        });
        
        await league_finish_awards.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return league_finish_awards;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const league_finish_awardsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                finish_rank: item.finish_rank
            ||
            null
            ,
            
                bonus_points: item.bonus_points
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const league_finish_awards = await db.league_finish_awards.bulkCreate(league_finish_awardsData, { transaction });

        // For each item created, replace relation files
        

        return league_finish_awards;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const league_finish_awards = await db.league_finish_awards.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.finish_rank !== undefined) updatePayload.finish_rank = data.finish_rank;
        
        
        if (data.bonus_points !== undefined) updatePayload.bonus_points = data.bonus_points;
        
        
        updatePayload.updatedById = currentUser.id;

        await league_finish_awards.update(updatePayload, {transaction});

        
        
        if (data.league !== undefined) {
            await league_finish_awards.setLeague(
              
              data.league,
              
              { transaction }
            );
        }
        
        if (data.player !== undefined) {
            await league_finish_awards.setPlayer(
              
              data.player,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await league_finish_awards.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return league_finish_awards;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const league_finish_awards = await db.league_finish_awards.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of league_finish_awards) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of league_finish_awards) {
                await record.destroy({transaction});
            }
        });


        return league_finish_awards;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const league_finish_awards = await db.league_finish_awards.findByPk(id, options);

        await league_finish_awards.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await league_finish_awards.destroy({
            transaction
        });

        return league_finish_awards;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const league_finish_awards = await db.league_finish_awards.findOne(
            { where },
            { transaction },
        );

        if (!league_finish_awards) {
            return league_finish_awards;
        }

        const output = league_finish_awards.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.league = await league_finish_awards.getLeague({
            transaction
        });
        
        
        output.player = await league_finish_awards.getPlayer({
            transaction
        });
        
        
        output.organizations = await league_finish_awards.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.leagues,
        as: 'league',
        
        where: filter.league ? {
          [Op.or]: [
            { id: { [Op.in]: filter.league.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.league.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.players,
        as: 'player',
        
        where: filter.player ? {
          [Op.or]: [
            { id: { [Op.in]: filter.player.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.player.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.finish_rankRange) {
                const [start, end] = filter.finish_rankRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    finish_rank: {
                    ...where.finish_rank,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    finish_rank: {
                    ...where.finish_rank,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.bonus_pointsRange) {
                const [start, end] = filter.bonus_pointsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    bonus_points: {
                    ...where.bonus_points,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    bonus_points: {
                    ...where.bonus_points,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.league_finish_awards.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'league_finish_awards',
                        'bonus_points',
                        query,
                    ),
                ],
            };
        }

        const records = await db.league_finish_awards.findAll({
            attributes: [ 'id', 'bonus_points' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['bonus_points', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.bonus_points,
        }));
    }

    
};

